/*
  Util.h : Utility routines
  Copyright (C) 2016, Yoshinori Tamada <tamada A T ytlab.jp>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright 
    notice, this list of conditions and the following disclaimer in 
    the documentation and/or other materials provided with the 
    distribution.

  * Neither the name of The University of Tokyo nor the names of its 
    contributors may be used to endorse or promote products derived 
    from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
  FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
  COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __PARAOS_UTIL_H
#define __PARAOS_UTIL_H

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

void Util_splitJobs(const uint64_t total, const int size, const int rank, 
                    uint64_t * quot, uint64_t * rem, 
                    uint64_t * bg, uint64_t * ed, uint64_t * elm);

void Util_splitJobs2(const uint64_t total, const int rank, 
                     const uint64_t quot, const uint64_t rem,
                     uint64_t * bg, uint64_t * ed, uint64_t * elm);

int Util_splitJobsRank(const uint64_t quot, const uint64_t rem,
                       const uint64_t id);

void Util_fprint_ar(FILE * fp, const int * ar, const size_t len);

uint8_t * Util_write_int32(uint8_t * buff, int32_t value);
const uint8_t * Util_read_int32(const uint8_t * buff, int32_t * value);
int32_t Util_readr_int32(const uint8_t * buff);
float Util_readr_float(const uint8_t * buff);
int8_t Util_readr_int8(const uint8_t * buff);

#endif /* __PARAOS_UTIL_H */

/* End of file. */
