/*
  Combo.{h,c} : Combination functions.
  Copyright (C) 2016, Yoshinori Tamada <tamada  A T  ytlab.jp>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:

  * Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

  * Redistributions in binary form must reproduce the above copyright 
    notice, this list of conditions and the following disclaimer in 
    the documentation and/or other materials provided with the 
    distribution.

  * Neither the name of The University of Tokyo nor the names of its 
    contributors may be used to endorse or promote products derived 
    from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
  FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
  COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.
*/
#ifndef __YTLIB_COMBO_H
#define __YTLIB_COMBO_H
#include <stdint.h>
#include <stdio.h>

uint64_t ytCombo_choose(int n, int k);
int ytCombo_generate(int n, int k, int * ar);
void ytCombo_indexTable(int n, uint64_t * table);
uint64_t ytCombo_chooseTable(int n, int k, const uint64_t * table, int tn);
uint64_t ytCombo_index(int n, int c, const int * ar, const uint64_t * table, int tn);
uint64_t ytCombo_index2(int n, int c, const int * ar, const int * a, const uint64_t * table, int tn);
uint64_t ytCombo_index3(int n, int c, const int * ar, const int * a, const int * b, const uint64_t * table, int tn);
void ytCombo_combination(int n, int c, uint64_t index, int * ar, 
                       const uint64_t * table, int tn);
void ytCombo_combination2(int n, int k, uint64_t index, int * ar, const int * a,
                        const uint64_t *table, int tn);
void ytCombo_combination3(int n, int k, uint64_t index, int * ar, 
                          const int * a, const int * b, 
                          const uint64_t * table, int tn);

void ytCombo_print(FILE * fp, size_t n, const int * A);
void ytCombo_print2(FILE * fp, size_t n, const int * A, const int * B);

void ytCombo_bitNext(uint64_t * bit);
void ytCombo_bit(int n, int k, uint64_t index, uint64_t * bit,
                 const uint64_t * table, int tn);

void ytCombo_bitCombo2(int n, int k, uint64_t index,
                       uint64_t * bit, int * A, const int * a,
                       const uint64_t * table, int tn);

void ytCombo_printBitCombo(FILE * fp, uint64_t bit, int n);


void ytCombo_test(FILE * fp);

#endif /* __YTLIB_COMBO_H */
/* End of file. */
